import React, { Component } from 'react'
import { Button, Card, Form, Input, message as Message, Popconfirm } from 'antd'
import { AntIcon, Auth, Container, ModalForm, QueryTable, QueryTableActions } from 'components'
import { api } from 'common/api'
import auth from 'components/authorized/handler'
import { isEqual } from 'lodash'
import getDictData from 'util/dic'
import { toCamelCase } from 'util/format'
import FormBody from './form'

/**
 * 注释段[\/**\/]为必须要改
 */

/**
 * 配置页面所需接口函数
 */
const apiAction = {
    page: api /**/,
    add: api /**/,
    edit: api /**/,
    delete: api /**/,
}

/**
 * 用于弹窗标题
 * [必要]
 */
const name = '/**/'

/**
 * 统一配置权限标识
 * [必要]
 */
const authName = '/**/'

export default class index extends Component {
    state = {
        codes: {},
    }

    // 表格实例
    table = React.createRef()

    // 新增窗口实例
    addForm = React.createRef()
    // 编辑窗口实例
    editForm = React.createRef()

    columns = []

    /**
     * 构造函数,在渲染前动态添加操作字段等
     * @param {*} props
     */
    constructor(props) {
        super(props)

        const flag = auth({ [authName]: [['edit'], ['delete']] })

        if (flag) {
            this.columns.push({
                title: '操作',
                width: 150,
                dataIndex: 'actions',
                render: (text, { id }) => (
                    <QueryTableActions>
                        <Auth auth={{ [authName]: 'edit' }}>
                            <a onClick={() => this.onOpen(this.editForm, id)}>编辑</a>
                        </Auth>
                        <Auth auth={{ [authName]: 'delete' }}>
                            <Popconfirm
                                placement="topRight"
                                title="是否确认删除"
                                onConfirm={() => this.onDelete(id)}
                            >
                                <a>删除</a>
                            </Popconfirm>
                        </Auth>
                    </QueryTableActions>
                ),
            })
        }
    }

    /**
     * 阻止外部组件引发的渲染,提升性能
     * 可自行添加渲染条件
     * [必要]
     * @param {*} props
     * @param {*} state
     * @returns
     */
    shouldComponentUpdate(props, state) {
        return !isEqual(this.state, state)
    }

    /**
     * 加载字典数据,之后开始加载表格数据
     * 如果必须要加载字典数据,可直接对表格设置autoLoad=true
     */
    componentDidMount() {
        const { onLoading, onLoadData } = this.table.current
        onLoading()
        getDictData(/**/).then(codes => {
            this.setState({ codes }, () => {
                onLoadData()
            })
        })
    }

    /**
     * 调用加载数据接口,可在调用前对query进行处理
     * [异步,必要]
     * @param {*} params
     * @param {*} query
     * @returns
     */
    loadData = async (params, query) => {
        const { data } = await apiAction.page({
            ...params,
            ...query,
        })
        return data
    }

    /**
     * 绑定字典数据
     * @param {*} code
     * @param {*} name
     * @returns
     */
    bindCodeValue(code, name) {
        name = toCamelCase(name)
        const codes = this.state.codes[name]
        if (codes) {
            const c = codes.find(p => p.code == code)
            if (c) {
                return c.value
            }
        }
        return null
    }

    /**
     * 打开新增/编辑弹窗
     * @param {*} modal
     * @param {*} id
     */
    onOpen(modal, id) {
        modal.current.open({ id })
    }

    /**
     * 对表格上的操作进行统一处理
     * [异步]
     * @param {*} action
     * @param {*} successMessage
     */
    async onAction(action, successMessage) {
        const { onLoading, onLoaded, onReloadData } = this.table.current
        onLoading()
        try {
            if (action) {
                await action
            }
            if (successMessage) {
                Message.success(successMessage)
            }
            onReloadData()
        } catch {
            onLoaded()
        }
    }

    /**
     * 删除
     * @param {*} id
     */
    onDelete(id) {
        this.onAction(apiAction.delete({ id }), '删除成功')
    }

    //#region 自定义方法
    //#endregion

    render() {
        return (
            <Container mode="fluid">
                <br />
                <Card bordered={false}>
                    <QueryTable
                        ref={this.table}
                        autoLoad={false}
                        loadData={this.loadData}
                        columns={this.columns}
                        query={<Auth auth={{ [authName]: 'page' }}></Auth>}
                        operator={
                            <Auth auth={{ [authName]: 'add' }}>
                                <Button
                                    icon={<AntIcon type="plus" />}
                                    onClick={() => this.onOpen(this.addForm)}
                                >
                                    新增{name}
                                </Button>
                            </Auth>
                        }
                    />
                </Card>

                <Auth auth={{ [authName]: 'add' }}>
                    <ModalForm
                        title={`新增${name}`}
                        action={apiAction.add}
                        ref={this.addForm}
                        onSuccess={() => this.table.current.onReloadData()}
                    >
                        <FormBody />
                    </ModalForm>
                </Auth>

                <Auth auth={{ [authName]: 'edit' }}>
                    <ModalForm
                        title={`编辑${name}`}
                        action={apiAction.edit}
                        ref={this.editForm}
                        onSuccess={() => this.table.current.onReloadData()}
                    >
                        <FormBody />
                    </ModalForm>
                </Auth>
            </Container>
        )
    }
}
